
 //change radion n rfid so starts only on button


#include <MySensor.h>  
#include <SPI.h>
#include <MFRC522.h>
#include <DallasTemperature.h>
#include <OneWire.h>

#define ONE_WIRE_POWER 5 // Pin where dallas sensor is powered 
#define ONE_WIRE_BUS 2 // Pin where dallase sensor is connected 
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
boolean receivedConfig = false;
boolean metric = true; 

/*Pin definitions*/
#define SS_PIN 8
#define RST_PIN 7
#define TONE_PIN 6   // Pin for the 8 ohms speaker to make tone

#define RFID_POWER 4 // define power pin for RFID

#define DIGITAL_INPUT_SENSOR 3   // The digital input you attached your motion sensor.  (Only 2 and 3 generates interrupt!)
#define INTERRUPT DIGITAL_INPUT_SENSOR-2 // Usually the interrupt = pin -2 (on uno/nano anyway)

#define CHILD_ID_LOCK 2   // Id of Lock
#define CHILD_ID_TEMP 1   // Id of Temp
#define CHILD_ID_VOLTAGE 3   // Id of the sensor child

/* Setup variables */
int BATTERY_SENSE_PIN = A0;  // select the input pin for the battery sense point
int oldValue=-1;

unsigned long SLEEP_TIME = 300000; // Sleep time between reports (in milliseconds)

boolean pinTriggered=0;//waitTime is number of seconds to hol in while loop

// notes in the melody:
int melody[2][10]={
  {330,330,330,330,0,0,0,0,0,0},
  {349,349,349,349,349,349,349,349,0,326}
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[2][10] = {
  {4,4,2,1,1,1,1,1,1,12},
  {12,12,12,12,12,12,12,4,1,2}
};

//time delay number of notes
int noteVariables[2][2] = {
  {0,1000},
  {4,10}
};

// array of the accepted cardnumbers
char* CardOk[]={"1986241970","711082311900"};

String cardnew; // the latest cardnumber read

bool lockStatus; // status of the lock

// Object definition
MFRC522 mfrc522(SS_PIN, RST_PIN);

MySensor gw;
MyMessage msgLock(CHILD_ID_LOCK, V_LOCK_STATUS);
MyMessage msgTemp(CHILD_ID_TEMP, V_TEMP);
MyMessage msgVoltage(CHILD_ID_VOLTAGE, V_VOLTAGE);


//#########################################################################################################
//######################################## Setup ##########################################################
//#########################################################################################################
void setup() { 
  Serial.begin(115200); // managed on the Mysensor config file Myconfig.h with DEBUG Option
  Serial.println("Setup is starting Up");

  // Startup OneWire 
    pinMode(ONE_WIRE_POWER,OUTPUT);

  // use the 1.1 V internal reference
  analogReference(INTERNAL);
    pinMode(A1,OUTPUT); 
      pinMode(A2, OUTPUT); 

  // Init mysensors library
gw.begin(incomingMessage);

  gw.sendSketchInfo("MYRFID Lock", "1.0");
  gw.present(CHILD_ID_LOCK, S_LOCK);
  gw.present(CHILD_ID_TEMP, S_TEMP);
  gw.present(CHILD_ID_VOLTAGE, S_POWER);
  
  lockStatus = gw.loadState(0);    // Read last lock status from eeprom (hwo shall we initialize it on GW?
  //setLockState(lockStatus, false); // Now set the last known state and send it to controller 

  
    pinMode(DIGITAL_INPUT_SENSOR,INPUT);      // sets the motion sensor digital pin as input
  digitalWrite(DIGITAL_INPUT_SENSOR,HIGH);   // Activate internal pull-up


  Serial.println("RF24 initialized and GW contacted");
  
pinMode(4,OUTPUT); // set output pin for RFID
gw.request(CHILD_ID_TEMP, V_TEMP);   

  
}


//#########################################################################################################
//################################# Loop for the Main program #############################################
//#########################################################################################################
void loop() {
gw.process(); // Process incomming messages 
digitalWrite(4,LOW);
  unsigned long time = millis();
  
  if (pinTriggered) {
digitalWrite(4,HIGH);
     
     //get request
     Serial.println("Request");
  gw.request(CHILD_ID_TEMP, V_TEMP);   
//turn on RFID
      //digitalWrite(RST_PIN,HIGH);
  delay(50);
mfrc522.PCD_Init(); 


    //turn on light
    if (lockStatus == 0) {
      digitalWrite(A1, HIGH);
    }
    else {
      digitalWrite(A2, HIGH);
    }   

    
    //delay(50);


    while ( millis() - time < 5000 && !mfrc522.PICC_IsNewCardPresent() ) {

       // Serial.print("Wait for Key Input: ");
       // Serial.println( millis() - time );
      	// Select one of the card    

    }

    checkCard();

   //Reset Pin value
     digitalWrite(A1, LOW);
      digitalWrite(A2, LOW);
      mfrc522.PCD_Reset();
digitalWrite(RST_PIN, LOW);

digitalWrite(4,LOW);       
pinTriggered=false;
      
  }
  else {
check_batt();

  // Turn onn and Fetch temperatures from Dallas sensors
    digitalWrite(ONE_WIRE_POWER,HIGH);
    delay(50);
      sensors.begin();
      sensors.requestTemperatures(); 

 
    // Fetch and round temperature to one decimal
    float temperature = static_cast<float>(static_cast<int>((gw.getConfig().isMetric?sensors.getTempCByIndex(0):sensors.getTempFByIndex(0)) * 10.)) / 10.;

  //Serial.print("Temperature: ");
 // Serial.print(temperature);
  //Serial.println(" C");
  
      // Send in the new temperature
      gw.send(msgTemp.set(temperature,1));  

  //turn off temp sensor
  digitalWrite(ONE_WIRE_POWER,LOW);
  }
  
  // Sleep until interrupt comes in on motion sensor. Send update every two minute.
  pinTriggered = gw.sleep(INTERRUPT, CHANGE, SLEEP_TIME);
}//end loop

void checkCard() {
 
	if ( ! mfrc522.PICC_ReadCardSerial()) {
		return;
	}   

  cardnew = String(mfrc522.uid.uidByte[0],DEC) + String(mfrc522.uid.uidByte[1],DEC) + String(mfrc522.uid.uidByte[2],DEC) + String(mfrc522.uid.uidByte[3],DEC) + String(mfrc522.uid.uidByte[4],DEC);
 // Serial.print("Card ID: ");
 //     Serial.println(cardnew);


    


  // Compare this key to the valid once registered here in sketch 
  bool correctKey = false;
    for (int i=0;i<sizeof(CardOk);i++) {
      if (cardnew==CardOk[i]) {
        correctKey = true;
      }
    }


if (correctKey == true) {
      setLockState(!lockStatus, true);  // Switch lock status   
}
else {
       setLockState(lockStatus, true);  // Switch lock status   
}

//end card readign


  
}

//#########################################################################################################
//######################################### Functions #####################################################
//#########################################################################################################

// Manage Unlock and Lock the door.
void setLockState(bool state, bool send){
  if (state) Serial.println("Alarm Enabled");
  else  Serial.println("Alarm Disabled");

  
    gw.saveState(0,state);
    lockStatus = state;
    
  if (send) {
  //Serial.println("Ring Ring");
  ring(state);
    gw.send(msgLock.set(state));
  }
  
}// end setLockState
//-------------------------------------------------------------------------------------------------------
// Manage incoming messages from Gateway 
void incomingMessage(const MyMessage &message) {
Serial.println("incoming");
  // We only expect one type of message from controller. But we better check anyway.
  if (message.type==V_TEMP) {    
    // Change relay state
    if (lockStatus != message.getBool() )
    setLockState(message.getBool(), false); 

    // Write some debug info
    Serial.print("Incoming lock status from GW:");
    Serial.println(message.getBool());
  } 
}//end incomingMessage
//-------------------------------------------------------------------------------------------------------
// Make melody when lock status change
void ring (int state) {

  // iterate over the notes of the melody:
  for (int thisNote = 0; thisNote < noteVariables[1][state]; thisNote++) {
    // to calculate the note duration, take one second divided by the note type.
    // e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations[state][thisNote];
    tone(TONE_PIN, melody[state][thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);

    // stop the tone playing:
    noTone(TONE_PIN);
    delay(noteVariables[0][state]);
  }  
  

}//end ring
//-------------------------------------------------------------------------------------------------------

void check_batt()
{
  // get the battery Voltage
  int sensorValue = analogRead(BATTERY_SENSE_PIN);
  //Serial.println(sensorValue);

  // 1M, 470K divider across battery and using internal ADC ref of 1.1V
  // Sense point is bypassed with 0.1 uF cap to reduce noise at that point
  // ((1e6+470e3)/470e3)*1.1 = Vmax = 3.44 Volts
  // 3.44/1023 = Volts per bit = 0.003363075
  float batteryV  = sensorValue * 0.003363075;
  int batteryPcnt = sensorValue / 10;

 // Serial.print("Battery Voltage: ");
  //Serial.print(batteryV);
 // Serial.println(" V");

 // Serial.print("Battery percent: ");
 // Serial.print(batteryPcnt);
 // Serial.println(" %");


    // Power up radio after sleep
   // gw.sendBatteryLevel(batteryPcnt);
      gw.send(msgVoltage.set(batteryV, 1));    

}



